#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_outfile=progressEx.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -add %out%, %out%, 1.bmp, bitmap, 1, 1031
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -add %out%, %out%, 2.bmp, bitmap, 2, 1031
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -add %out%, %out%, 3.bmp, bitmap, 3, 1031
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -add %out%, %out%, 4.bmp, bitmap, 4, 1031
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -add %out%, %out%, 5.bmp, bitmap, 5, 1031
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -add %out%, %out%, 6.bmp, bitmap, 6, 1031
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\Aut2Exe\upx.exe --best --compress-resources=1 "%out%"
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include-once
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>


Opt('OnExitFunc', 'Terminate')

$NULL = Ptr(0)
Global Const $SS_CENTER = 1
Global $SS_NOTIFY = 0x0100
Global $LR_LOADFROMFILE = 16
Global $STM_SETIMAGE = 0x0172
Global $IMAGE_BITMAP = 0
Global $gdi32dll    = DllOpen('gdi32.dll')
Global $user32dll   = DllOpen('user32.dll')
Global $kernel32dll = DllOpen('kernel32.dll')
Global $hBitmap[7]

$hInst = GetModuleHandle()

; Bitmaps laden.
For $i = 1 To 6
	
	; to work with resources use LoadImage like in the line below
	; and correct the pathes in #AutoIt3Wrapper_Run_After.
;	$hBitmap[$i] = LoadImage($hInst, $i, $IMAGE_BITMAP)

	; to work with Bitmaps on Harddisk take this line
	$hBitmap[$i] = LoadImage($NULL, String($i) & '.bmp', $IMAGE_BITMAP, 0, 0, $LR_LOADFROMFILE)
	
Next


; Testfenster erstellen.
$hWnd = GUICreate('ProgressBar mit Bitmaps - Demo', 500, 300, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
GUISetBkColor(0xFFFFFF)
GUISetFont(10, 800, 0, 'SegoeUI')

GUICtrlCreateLabel('Progressbar Test', 0, 80, 500, 20, $SS_CENTER)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont(-1, 12, 800, 0, 'SegoeUI')

$aProgressBar1 = ProgressBarCreate(100, 150, 300, $hWnd)

GUISetState(@SW_SHOW, $hWnd)
ProgressBarSetState($aProgressBar1)
;_ArrayDisplay($aProgressBar1)

$aProgressBar2 = ProgressBarCreate(100, 150, 500)
ProgressBarSetState($aProgressBar2)

Sleep(1500)
TestProgress($aProgressBar1)
TestProgress($aProgressBar2)

;Sleep(1500)
;ProgressBarDelete($aProgressBar1)
;ProgressBarDelete($aProgressBar2)

While True
	
	Switch GUIGetMsg()
		Case -3
			Exit
	EndSwitch
	
WEnd

Func TestProgress($aProgress)
	
	For $i = 1 To 100
		ProgressBarSetData($aProgress, $i)
		Sleep(10)
	Next
	
EndFunc

Func ProgressBarCreate($x, $y, $iWidth, $hWndParent = 0)
	
	Local $dwExStyleCtrl, $aProgress[2][$iWidth + 1]
	$aProgress[1][0] = $iWidth
	
	If Not $hWndParent Or $hWndParent = 0 Then
		$aProgress[0][0] = GUICreate('ProgressBar', $iWidth, 15, $x, $y, BitOR($WS_CLIPCHILDREN, $WS_CLIPSIBLINGS, $WS_POPUP), $WS_EX_LAYERED)
		$dwExStyleCtrl = BitOr($WS_EX_LAYERED,$GUI_WS_EX_PARENTDRAG)
	Else
		$aProgress[0][0] = GUICreate('ProgressBar', $iWidth, 15, $x, $y, BitOR($WS_DISABLED, $WS_CLIPCHILDREN, $WS_CLIPSIBLINGS, $WS_POPUP), BitOr($WS_EX_LAYERED, $WS_EX_MDICHILD), $hWndParent)
	EndIf
	
	$aProgress[1][1] = GUICtrlCreatePic('', 0, 0, 2, 15, BitOR($WS_CLIPSIBLINGS, $SS_NOTIFY,$WS_GROUP), $dwExStyleCtrl)
	GUICtrlSetState(-1, $GUI_ONTOP)
	GUICtrlSendMsg($aProgress[1][1], $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap[1])
	
	For $i = 2 To $iWidth - 2
		$aProgress[1][$i] = GUICtrlCreatePic('', $i, 0, 1, 15, BitOR($WS_CLIPSIBLINGS, $SS_NOTIFY, $WS_CHILD), $dwExStyleCtrl)
		GUICtrlSetState(-1, $GUI_ONTOP)
		GUICtrlSendMsg($aProgress[1][$i], $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap[3])
	Next
	
	$aProgress[1][$iWidth] = GUICtrlCreatePic('', $iWidth - 2, 0, 2, 15, BitOR($WS_CLIPSIBLINGS, $SS_NOTIFY,$WS_GROUP), $dwExStyleCtrl)
	GUICtrlSetState(-1, $GUI_ONTOP)
	GUICtrlSendMsg($aProgress[1][$iWidth], $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap[2])
	
	$aProgress[0][1] = GUICtrlCreateLabel('', ($iWidth / 2) -15, 0, 40, 15, BitOR($SS_CENTER , $WS_CHILD), $dwExStyleCtrl)
	GUICtrlSetColor(-1,0x424242)
	GUICtrlSetFont(-1, 8.5, 800, 0, 'SegoeUI')
	If Not $hWndParent Then GUICtrlSetTip(-1, "Drag me, please ... ;) ")
	
	Return $aProgress
	
EndFunc

Func ProgressBarSetData($aProgress, $iPercent)
	
	$iSize = ($aProgress[1][0] / 100)
	$cxEnd = $iSize * $iPercent
	$cxStart = $cxEnd - ($iSize - 1)
	
	ProgressSetText($aProgress, $iPercent & ' %')
	
	For $i = Int($cxStart) To Int($cxEnd)
		If $i = 1 Then
			GUICtrlSendMsg($aProgress[1][1], $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap[5])
		ElseIf $iPercent = 100 And $i = Int($cxEnd) Then
			GUICtrlSendMsg($aProgress[1][$aProgress[1][0]], $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap[6])
		Else
			GUICtrlSendMsg($aProgress[1][$i], $STM_SETIMAGE, $IMAGE_BITMAP, $hBitmap[4])
		EndIf
	Next
	
EndFunc

Func ProgressBarSetState($aProgress, $State = @SW_SHOW)
	
	GUISetState($State, $aProgress[0][0])
	
	GUICtrlSetBkColor($aProgress[0][1], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetData($aProgress[0][1], '0 %')
	GUICtrlSetState($aProgress[0][1], $GUI_ONTOP)
	
EndFunc

Func ProgressBarDelete($aProgress)
	
	If $aProgress[0][0] Then
		GUIDelete($aProgress[0][0])
	Else
		For $i = 1 To $aProgress[1][0]
			GUICtrlSendMsg($aProgress[1][$i], $WM_CLOSE, 0, 0)
		Next
	EndIf
	
EndFunc

Func ProgressSetText($aProgress, $sText)
	
	GUICtrlSetState($aProgress[0][1], $GUI_HIDE)
	GUICtrlSetData($aProgress[0][1], $sText)
	GUICtrlSetState($aProgress[0][1], $GUI_SHOW)
	GUICtrlSetState($aProgress[0][1], $GUI_ONTOP)

EndFunc

Func LoadImage($hInstance, $lpszName, $uType, $cxDesired = 0, $cyDesired = 0, $fuLoad = 0)
	
	If IsNumber($lpszName) Then $lpszName = MAKEINTRESOURCE($lpszName)
	Local $aResult = DllCall($user32dll, 'hwnd', 'LoadImage', _
													'ptr',  $hInstance, _
													'str',  $lpszName, _
													'uint', $uType, _
													'int',  $cxDesired, _
													'int',  $cyDesired, _
													'uint', $fuLoad)
	Return $aResult[0]
	
EndFunc

Func GetModuleHandle($sModule = '')
	
	Local $aResult = DllCall($kernel32dll, 'hwnd', 'GetModuleHandle', 'ptr', StringLeft($sModule, 4095) & Chr(0))
	
	Return $aResult[0]
	
EndFunc

Func DeleteObject($hObject)
	
	Local $aResult = DllCall($gdi32dll, 'int', 'DeleteObject', 'hwnd', $hObject)
	Return $aResult[0]
	
EndFunc

Func MAKEINTRESOURCE($lID)
	
	Return "#" & String(Int($lID))
	
EndFunc

Func Terminate()
	
	For $i = 1 To 6
		
		DeleteObject($hBitmap[$i])
		
	Next
	
	DllClose($gdi32dll)
	DllClose($user32dll)
	DllClose($kernel32dll)
	
EndFunc














